#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <sys/stat.h>

#include "asim/rrr/service_ids.h"

#include "asim/provides/connected_application.h"

using namespace std;

unsigned int reverse_uint(unsigned int o) {
	union {
		unsigned int i;
		unsigned char c[4];
	} ita;
	ita.i = o;
	unsigned char t = ita.c[0];
	ita.c[0] = ita.c[3];
	ita.c[3] = t;
	t = ita.c[1];
	ita.c[1] = ita.c[2];
	ita.c[2] = t;
	return ita.i;
}

unsigned int total_loads = 0;
void decompress_done() {
	printf( "Decompression Done!\n" );
	printf( "Total Instr Cache misses: %d\n", total_loads );
	fflush(stdout);
	exit(0);
}
//FIXME:: the varbit and REG stuff isn't done in the binary output. FIXME!!

void print_decompressed_bin(FILE* fdecompressed, unsigned int v0, unsigned int v1, unsigned int v2) {
		unsigned char traceType = v0 >> 16;
		unsigned char size = (v0 >> 8) % 32;
		unsigned char target = v0 % 32;
		unsigned char varbit = (v0 >> 5) % 2;
		unsigned int data[3];


		data[0] = v0;
		data[1] = v1;
		data[2] = v2;
		
		if ( traceType == TAG_MEMREAD && varbit && target > 0 ) {
			data[0] = (TAG_MEMREAD << 16) + (size << 8) + (target); 
			fwrite(data, sizeof(unsigned int), 3, fdecompressed);

			data[0] = (TAG_REG << 16) + target; 
			data[1] = v2;
			data[2] = 0;
			fwrite(data, sizeof(unsigned int), 3, fdecompressed);
		} else {
			fwrite(data, sizeof(unsigned int), 3, fdecompressed);
		}
}
unsigned int output_decompressed_count;
unsigned int *decompr_buff;
unsigned int decompr_buff_idx;
void output_decompressed_bin(FILE* fdecompressed, unsigned int flags, unsigned int pc, unsigned int addr, unsigned int value) {
	if ( flags >> 31 ) {
		fwrite(decompr_buff, sizeof(unsigned int), decompr_buff_idx, fdecompressed);
		printf( "end!!%d\nforcedwrite - %d\n", output_decompressed_count, decompr_buff_idx );
		fflush(stdout);
		decompress_done();
		return;
	}
	/*
	output_decompressed_count += 1;

	decompr_buff[decompr_buff_idx] = flags;
	decompr_buff[decompr_buff_idx+1] = addr;
	decompr_buff[decompr_buff_idx+2] = value;
	decompr_buff[decompr_buff_idx+3] = pc;
	decompr_buff_idx += 4;
	*/

	unsigned int data[4];
	data[0] = flags;
	data[1] = addr;
	data[2] = value;
	data[3] = pc;
	fwrite(data, sizeof(unsigned int), 4, fdecompressed);
	/*
	if ( decompr_buff_idx >= COMPR_BUFF_SIZE - 4 ) {
		fwrite(decompr_buff, sizeof(unsigned int), decompr_buff_idx, fdecompressed);
//		printf( "write - %d\n", decompr_buff_idx );
//		fflush(stdout);
		decompr_buff_idx = 0;//(decompr_buff_idx + 4)%COMPR_BUFF_SIZE;
	}*/
}

void print_decompressed_string(FILE* fdecomprstring, unsigned int v0, unsigned int v1, unsigned int v2) {
		unsigned char traceType = v0 >> 16;
		unsigned char size = (v0 >> 8) % 32;
		unsigned char target = v0 % 32;
		unsigned char varbit = (v0 >> 5) % 2;
		switch ( traceType ) {
		 case TAG_MATCH:
		 	fprintf( fdecomprstring, "TAG_MATCH?!\n" );
		 break;
		 case TAG_STEP:
		 	fprintf( fdecomprstring, "STEP%x\n#\n", v1 );
		 break;
		 case TAG_REG:
		 	fprintf( fdecomprstring, "REG %02d 00 %x\n", target, v1 );
		 break;
		 case TAG_MEMREAD:
		 	fprintf( fdecomprstring, "MEM_READ %012x %02d %x\n", v1, size, v2 );
		 
		 	if ( varbit && target > 0 )
		 		fprintf( fdecomprstring, "REG %02d 00 %x\n", target, v2 );
		 break;
		 case TAG_MEMWRITE:
		 	fprintf( fdecomprstring, "MEM_WRITE %012x %02d %x\n", v1, size, v2 );
		 break;
		}
//		printf( "~%d[%d:%d] %x %x\n", traceType, size, target, v1, v2 );
	
}
void output_decompressed_string(FILE* fdecomprstring, unsigned int flags, unsigned int pc, unsigned int addr, unsigned int value) {
	unsigned char regChange = (flags>>16)&1;
	unsigned char memAcc = (flags>>17)&3;
	unsigned char size = (flags>>19)&31;
	unsigned char target = (flags>>24)&31;

	if (memAcc == 1) { // memAccRead
		fprintf( fdecomprstring, "MEM_READ %012x %02d %x\n", addr, size, value );
	} else if (memAcc == 2) {
		fprintf( fdecomprstring, "MEM_WRITE %012x %02d %x\n", addr, size, value );
	}
	if (regChange) {
		fprintf( fdecomprstring, "REG %02d 00 %x\n", target, value );
	}
	if ( pc ) fprintf( fdecomprstring, "STEP%x\n#\n", pc );

}

// ===== service instantiation =====
PROCESSORSYSTEMRRR_SERVER_CLASS PROCESSORSYSTEMRRR_SERVER_CLASS::instance;

// constructor
PROCESSORSYSTEMRRR_SERVER_CLASS::PROCESSORSYSTEMRRR_SERVER_CLASS() :
  serverStub(new PROCESSORSYSTEMRRR_SERVER_STUB_CLASS(this))//,
//  clientStub(new PROCESSORSYSTEMRRR_CLIENT_STUB_CLASS(this))
{
		// wjun
		FILE* fexec = fopen("exec.bin", "rb");
		if ( fexec ) {
			int t;
			t = fread(&pc, sizeof(unsigned int), 1, fexec);
			t = fread(&ioffset, sizeof(unsigned int), 1, fexec);
			t = fread(&isize, sizeof(unsigned int), 1, fexec);
			idata = (unsigned int*)malloc(isize + 32);
			t = fread(idata, isize, 1, fexec);
			
			fclose(fexec);
			printf( "exec file opened:%x[%x]\n", ioffset ,isize );
		} else {
			printf( "exec.bin not found!!\n" );
			pc = 0;
			ioffset = 0;
			isize = 0;
			idata = NULL;
			exit(1);
		}
		fcompressed = fopen("compressed.bin", "rb");
		fdecompressed = fopen("decompressed.bin", "wb");
		fdecomprstring = fopen("decompr.txt", "w");
		fdecomprbin = fopen("decompr.bin", "w");
		if ( !fcompressed || !fdecomprstring || !fdecompressed || !fdecomprbin ) {
			printf( "Some file failed to open!!\n" );
			fflush(stdout);
			exit(1);
		}
		compr_buff = (unsigned int*)malloc(sizeof(unsigned int)*COMPR_BUFF_SIZE);
//		compr_buff_loaded = fread(compr_buff, sizeof(unsigned int), COMPR_BUFF_SIZE/2, fcompressed);
		compr_buff_idx = 0;
		compr_buff_lowhalf_loaded = 1;
		compr_buff_highhalf_loaded= 0;
		decompr_buff = (unsigned int*)malloc(sizeof(unsigned int)*COMPR_BUFF_SIZE);
		decompr_buff_idx = 0;
		decompr_instr_count = 0;

    // instantiate stub
    memory = NULL;
    fflush(stdout);
}


// destructor
PROCESSORSYSTEMRRR_SERVER_CLASS::~PROCESSORSYSTEMRRR_SERVER_CLASS()
{
    Cleanup();
}

// init
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)
{
    parent = p;
}

// uninit
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Uninit()
{
    Cleanup();
}

// cleanup
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Cleanup()
{
    delete serverStub;
}


//
// RRR service methods
//
// wjun
//UINT32
OUT_TYPE_InstrRequestLoad
PROCESSORSYSTEMRRR_SERVER_CLASS::InstrRequestLoad (UINT32 address)
{
	printf( "Recv Sending Instr Req%x;\n", address);
	fflush(stdout);
//  UINT32 returnVal;
	OUT_TYPE_InstrRequestLoad rv;
	rv.value0 = 0;
	rv.value1 = 0;
	rv.value2 = 0;
	rv.value3 = 0;
	rv.value4 = 0;
	rv.value5 = 0;
	rv.value6 = 0;
	rv.value7 = 0;
	unsigned int idx = (address - ioffset);
	total_loads ++;

	
  //returnVal = 0xcccccc;
	if ( idx >= 0 && idx < isize ) {
		rv.value0 = reverse_uint( idata[idx>>2] );
		rv.value1 = reverse_uint( idata[(idx>>2)+1] );
		rv.value2 = reverse_uint( idata[(idx>>2)+2] );
		rv.value3 = reverse_uint( idata[(idx>>2)+3] );
		rv.value4 = reverse_uint( idata[(idx>>2)+4] );
		rv.value5 = reverse_uint( idata[(idx>>2)+5] );
		rv.value6 = reverse_uint( idata[(idx>>2)+6] );
		rv.value7 = reverse_uint( idata[(idx>>2)+7] );
//		printf( "Fetched %x(%x)\n", address, returnVal );
	}
	printf( "Sending Instr%x;\n", address );
	fflush(stdout);
	return rv;
}

void
PROCESSORSYSTEMRRR_SERVER_CLASS::SendResult(UINT32 flags1, UINT32 addr1, UINT32 value1, UINT32 pc1, 
				UINT32 flags2, UINT32 addr2, UINT32 value2, UINT32 pc2, 
				UINT32 flags3, UINT32 addr3, UINT32 value3, UINT32 pc3, 
				UINT32 flags4, UINT32 addr4, UINT32 value4, UINT32 pc4) 
{
	//printf( "SendResult rec\n" );fflush(stdout);
	decompr_instr_count += 4;
//	output_decompressed_string(fdecomprstring, flags1, pc1, addr1, value1);
	output_decompressed_bin(fdecomprbin, flags1, pc1, addr1, value1);
//	output_decompressed_string(fdecomprstring, flags2, pc2, addr2, value2);
	output_decompressed_bin(fdecomprbin, flags2, pc2, addr2, value2);
	
//	output_decompressed_string(fdecomprstring, flags3, pc3, addr3, value3);
	output_decompressed_bin(fdecomprbin, flags3, pc3, addr3, value3);
//	output_decompressed_string(fdecomprstring, flags4, pc4, addr4, value4);
	output_decompressed_bin(fdecomprbin, flags4, pc4, addr4, value4);
	//printf( "SendResult resp\n" );fflush(stdout);
	return;
}

void
PROCESSORSYSTEMRRR_SERVER_CLASS::SingleCompressed(unsigned int* rv)
{
	rv[1] = 0;
	rv[2] = 0;
	rv[3] = 0;

	if ( compr_buff_idx >= COMPR_BUFF_SIZE ) {
		compr_buff_idx = compr_buff_idx % COMPR_BUFF_SIZE;
	}
	
	if ( compr_buff_idx >= compr_buff_loaded && feof(fcompressed )) {
		printf( "end! %x %x\n", compr_buff_idx, compr_buff_loaded );
		fflush(stdout);
		rv[0] = 1 << 31;
		return;
	}
	
	if (!compr_buff_lowhalf_loaded && compr_buff_idx > COMPR_BUFF_SIZE/2) {
		compr_buff_highhalf_loaded = 0;
		compr_buff_lowhalf_loaded = 1;
		if ( fcompressed && !feof(fcompressed) ) {
			compr_buff_loaded = fread(compr_buff, sizeof(unsigned int), COMPR_BUFF_SIZE/2, fcompressed);
		}
	} else if (!compr_buff_highhalf_loaded && compr_buff_idx < COMPR_BUFF_SIZE/2) {
		if ( fcompressed && !feof(fcompressed) ) {
			compr_buff_loaded = fread(compr_buff + COMPR_BUFF_SIZE/2, sizeof(unsigned int), COMPR_BUFF_SIZE/2, fcompressed);
			compr_buff_loaded += COMPR_BUFF_SIZE/2;
		}
		compr_buff_highhalf_loaded = 1;
		compr_buff_lowhalf_loaded = 0;
	}

	rv[0] = compr_buff[compr_buff_idx];
	if (rv[0]%(1<<16)) {
		compr_buff_idx += 1;
		return;
//		return rv;
	}
	// order of flags, addr, value, pc
	rv[1] = compr_buff[(compr_buff_idx+1)%COMPR_BUFF_SIZE];
	rv[2] = compr_buff[(compr_buff_idx+2)%COMPR_BUFF_SIZE];
	rv[3] = compr_buff[(compr_buff_idx+3)%COMPR_BUFF_SIZE];
	compr_buff_idx += 4;
	return;
}

//			 method ReqCompressed (in UINT32[32] a, out UINT32[32] flags1, out UINT32[32] addr1, out UINT32[32] value1, out UINT32[32] pc1, out UINT32[32] flags2, out UINT32[32] addr2, out UINT32[32] value2, out UINT32[32] pc2, out UINT32[32] flags3, out UINT32[32] addr3, out UINT32[32] value3, out UINT32[32] pc3, out UINT32[32] flags4, out UINT32[32] addr4, out UINT32[32] value4, out UINT32[32] pc4);
OUT_TYPE_ReqCompressed 
PROCESSORSYSTEMRRR_SERVER_CLASS::ReqCompressed(UINT32 a)
{
	printf( "req - " ); fflush(stdout);
	unsigned int sv[4];
	OUT_TYPE_ReqCompressed rv;
	SingleCompressed(sv);
	rv.flags1 = sv[0];
	rv.addr1 = sv[1];
	rv.value1 = sv[2];
	rv.pc1 = sv[3];
	SingleCompressed(sv);
	rv.flags2 = sv[0];
	rv.addr2 = sv[1];
	rv.value2 = sv[2];
	rv.pc2 = sv[3];
	SingleCompressed(sv);
	rv.flags3 = sv[0];
	rv.addr3 = sv[1];
	rv.value3 = sv[2];
	rv.pc3 = sv[3];
	SingleCompressed(sv);
	rv.flags4 = sv[0];
	rv.addr4 = sv[1];
	rv.value4 = sv[2];
	rv.pc4 = sv[3];
	printf( "req\n" ); fflush(stdout);
	return rv;
}
extern int g_resQCount;
extern pthread_mutex_t lock_gVar;
//void
UINT32
PROCESSORSYSTEMRRR_SERVER_CLASS::SendQAvail(UINT32 availCount)
{
	//TODO need mutex?
	printf("Recv SendQAvail\n");fflush(stdout);
	pthread_mutex_lock(&lock_gVar);
	g_resQCount += availCount/4;
	printf("SendQAvail %d -> %d\n", availCount, g_resQCount);fflush(stdout);
	pthread_mutex_unlock(&lock_gVar);
	printf("End SendQAvail\n");fflush(stdout);
	return availCount;
	/*
	int i;
	printf( "Received req for %d\n", availCount );
	fflush(stdout);
	for ( i = 0; i < (availCount/4); i++ ) {
		printf( "Sent %d\n", i );
		fflush(stdout);
//		OUT_TYPE_ReqCompressed rv;
		unsigned int rv[16];
		ReqCompressed(rv);
		clientStub->RespCompressed(
			rv[0], rv[1], rv[2], rv[3],
			rv[4+0], rv[4+1], rv[4+2], rv[4+3],
			rv[8+0], rv[8+1], rv[8+2], rv[8+3],
			rv[12+0], rv[12+1], rv[12+2], rv[12+3]
		);
	}
	printf( "Replied req for %d\n", availCount );
	fflush(stdout);
	*/
}
